## papilo 2.4.1%2Bds

=== debian/changelog ===
papilo (2.4.1+ds-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:05:57 +0200

papilo (2.4.1+ds-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:55:33 +0200

papilo (2.4.1+ds-1) unstable; urgency=medium

  * Fix FTBFS with fmtlib 10.1.1
  * New upstream version 2.4.1+ds
  * Update patches
    - Drop 0001-Add-BUILD_TESTING-support.patch (obsolete)
  * Update d/copyright
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Mon, 10 Feb 2025 11:01:56 +0100

papilo (2.3.0+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1083119)

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Oct 2024 01:33:09 +0200
