=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILD_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_TESTING=$(BUILD_TESTING) \
		-DBUILD_SHARED_LIBS=ON \
		-DPAPILO_CLUSOL_SOVERSION=0d \
		-DPAPILO_CORE_SOVERSION=0d

override_dh_auto_test:
	-dh_auto_test --buildsystem=cmake

execute_before_dh_installman:
	sed -e 's/@VERSION@/$(DEB_VERSION_UPSTREAM)/g' debian/papilo.1.in > debian/papilo.1
