=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,uversionmangle=s%[.-]?(a|b|c|rc|dev|pre)%~$1%;s%^\d\d\d.*%~0.ignore%,dversionmangle=auto,oversionmangle=s%$%+ds%,repack \
 https://api.github.com/repos/scipopt/papilo/tags \
 tarball/(?:[^"]*?/)?[a-z]*@ANY_VERSION@
