## papilo 2.4.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 set(PAPILO_VERSION_MAJOR 2)
 set(PAPILO_VERSION_MINOR 4)
-set(PAPILO_VERSION_PATCH 1)
+set(PAPILO_VERSION_PATCH 3)
 set(PAPILO_API_VERSION 3)
 
 project(papilo VERSION ${PAPILO_VERSION_MAJOR}.${PAPILO_VERSION_MINOR}.${PAPILO_VERSION_PATCH}.0)
@@ -344,14 +344,14 @@
 # TODO: Simplify with a generator expression.
 function(setLibProperties targetname outputname)
     set_target_properties(${targetname} PROPERTIES
-        OUTPUT_NAME ${outputname}
-        MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+        OUTPUT_NAME ${outputname})
 endfunction(setLibProperties)
 if(MSVC)
     setLibProperties(papilo-core "libpapilo-core")
 else()
-   setLibProperties(papilo-core "papilo-core")
+    setLibProperties(papilo-core "papilo-core")
 endif()
 
 
 # Add dependency-target `papilo` to static library-target `papilo-core`.
+target_link_libraries(papilo-core papilo)
