=== debian/changelog ===
papilo (2.4.3+ds-1) unstable; urgency=medium

  * New upstream version 2.4.3+ds
  * Refresh patches (no functional changes)
  * Fix Multi-Arch conflict on CMakeConfig.hpp
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Wed, 20 Aug 2025 10:38:44 +0200
