## papilo 2.4.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 set(PAPILO_VERSION_MAJOR 2)
 set(PAPILO_VERSION_MINOR 4)
-set(PAPILO_VERSION_PATCH 3)
+set(PAPILO_VERSION_PATCH 4)
 set(PAPILO_API_VERSION 3)
 
 project(papilo VERSION ${PAPILO_VERSION_MAJOR}.${PAPILO_VERSION_MINOR}.${PAPILO_VERSION_PATCH}.0)
