=== binaries/CMakeLists.txt ===
--- 
+++ 
@@ -161,7 +161,6 @@
    if(PAPILO_HAVE_HIGHS)
       list(APPEND linked_solvers "HiGHS")
       set(PAPILO_HAVE_HIGHS 1 PARENT_SCOPE)
-      find_package(OpenMP)
       target_compile_definitions(papilo-executable PRIVATE PAPILO_HAVE_HIGHS)
       target_link_libraries(papilo-executable highs::highs)
    endif()
