=== check/parser/requirements.txt ===
dataclasses
numpy
