=== debian/changelog ===
papilo (2.4.4+ds-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 2.4.4+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Mon, 27 Oct 2025 22:35:58 +0100
