=== debian/control ===
Source: papilo
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 catch2 <!nocheck>,
 cmake,
 gfortran,
 libblas-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libfmt-dev,
 libsoplex-dev,
 libtbb-dev (>= 2020),
Homepage: https://github.com/scipopt/papilo
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/math-team/papilo.git
Vcs-Browser: https://salsa.debian.org/math-team/papilo
Description: Parallel Presolve for Integer and Linear Optimization
 PaPILO, a C++14-based software package, provides parallel presolve routines
 for (mixed integer) linear programming problems. The routines are implemented
 using templates which allows switching to higher precision or rational
 arithmetic using the boost multiprecision package.

Package: papilo
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package installs an executable for presolving and postsolving MILP
 instances based on files. The executable can also act as frontend for the
 SoPlex solver.

Package: libpapilo-clusol0d
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (LUSOL library)
 ${source:Extended-Description}
 .
 This package installs the shared PaPILO LUSOL library.

Package: libpapilo-core0d
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (core library)
 ${source:Extended-Description}
 .
 This package installs the shared PaPILO core library.

Package: libpapilo-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libboost-dev (>= 1.65),
 libpapilo-clusol0d (= ${binary:Version}),
 libpapilo-core0d (= ${binary:Version}),
 libtbb-dev (>= 2020),
 ${misc:Depends},
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides the necessary files to develop and link against the
 PaPILO library.
