=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 BUILD_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
+
+include /usr/share/dpkg/architecture.mk
 
 %:
 	dh $@ --buildsystem=cmake
@@ -20,3 +22,8 @@
 execute_before_dh_installman:
 	sed -e 's/@VERSION@/$(DEB_VERSION_UPSTREAM)/g' debian/papilo.1.in > debian/papilo.1
 
+execute_after_dh_auto_install:
+	# Fix Multi-Arch conflict due to architecture-specific settings in auto-generated config file
+	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/papilo
+	mv debian/tmp/usr/include/papilo/CMakeConfig.hpp debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/papilo
+
