=== debian/watch ===
Version: 5

Template: Github
Owner: scipopt
Project: papilo
Uversion-Mangle: auto
Dversion-Mangle: auto
Repack-Suffix: +ds
Repack: yes
